#define tests 10
#define maxn 2000
#define maxm 450000
#include <stdio.h>
#include <windows.h>
#include <math.h>
#include <vector>

using namespace std;

int n, m, i, j, a, b, ec, test;
int rooms[maxn], e[maxm][2];
long ms, total_ms;
bool changed;
double file_ms, tl_ms, correct_ms;
vector<int> g[maxn];

LARGE_INTEGER it1, it2, ifreq;

void startTiming()
{
     QueryPerformanceCounter(&it1);     
}

void endTiming()
{
     QueryPerformanceCounter(&it2); 
     ms = (int) round(1000 * ((double) (it2.QuadPart - it1.QuadPart)) / ifreq.QuadPart);
     total_ms += ms;     
     //printf("%d\n", ms);
}

double getAverage()
{
       double result = ((double) total_ms) / tests;
       //printf("%f\n\n", result);
       return result;          
}

bool dfs(int v, int room)
{
     rooms[v] = room;
     for (int i = 0; i < g[v].size(); i++)
     {
         int w = g[v][i];
         if (rooms[w] == 0)
         {
            if (! dfs(w, 3 - room))
               return false;
         }
         else if (rooms[w] == room)
              return false;    
     }
     return true;
}

int main()
{    
    printf("Please turn off antivirus software and shut down any processes that might slow down the execution time.\n\n");
    system("pause");    
    
    FILE * infile;
    
    n = 0;
    infile = fopen("olympiad_time.in", "r");    
    fscanf(infile, "%d %d", &n, &m);
    if (n != 1998)
    {
       printf("\nPlease put the OLYMPIAD_TIME.IN file into the same directory with OLYMPIAD_TIME.EXE and run again.\n\n");
       system("pause");
       return 0;      
    }
    
    printf("\nComputing...\n");
    
    QueryPerformanceFrequency(&ifreq);
    
    total_ms = 0;
    for (test = 0; test <= tests; test++)
    {
        if (test > 0)
           startTiming();

        infile = fopen("olympiad_time.in", "r");    
        fscanf(infile, "%d %d", &n, &m);
        ec = 0;
        for (i = 0; i < m; i++)
        {
            fscanf(infile, "%d %d", &a, &b);
            e[ec][0] = a - 1;
            e[ec][1] = b - 1;
            ec++;
        }
        fclose(infile);  
        
        if (test > 0)
           endTiming();
    }
    file_ms = getAverage();
    
    total_ms = 0;
    for (test = 0; test < tests; test++)
    {
        startTiming();
        for (i = 0; i < n; i++)
            rooms[i] = 0;
        rooms[0] = 1;
        changed = true;
        while (changed)
        {
            changed = false;
            for (j = 0; j < m; j++)
            {
                a = e[j][0];
                b = e[j][1];
                if (rooms[a] != 0 && rooms[b] != 0 && rooms[a] == rooms[b])
                {
                   printf("0\n0\n");
                   return 0;             
                }
                if (rooms[a] != 0 && rooms[b] == 0)
                {
                   rooms[b] = 3 - rooms[a];
                   changed = true;
                }
                else if (rooms[a] == 0 && rooms[b] != 0)
                {
                     rooms[a] = 3 - rooms[b];
                     changed = true;
                }
            }
        }
        endTiming();
    }
    tl_ms = getAverage();
    
    total_ms = 0;
    for (test = 0; test < tests; test++)
    {
        for (i = 0; i < n; i++)
            g[i].clear();
        
        startTiming();
        
        for (i = 0; i < m; i++)
        {
            a = e[i][0];
            b = e[i][1];
            g[a].push_back(b);
            g[b].push_back(a);
        }
        for (i = 0; i < n; i++)
            rooms[i] = 0;
            
        if (dfs(0, 1))
        {
            for (i = 0; i < n; i++)
                if (rooms[i] == 0)
                    break;            
        }    
            
        endTiming();
    }
    correct_ms = getAverage();
    
    if (tl_ms < 500)
       printf("\nThis computer is too quick for proper testing of the OLYMPIAD problem.\n");
    else
    {
       printf("\nThe time limit for the OLYMPIAD problem should be\n");
       printf("%d milliseconds\n\n", 10 * ((int) round((50 + file_ms + sqrt(tl_ms * correct_ms)) / 10)));    
    }
 
    system("pause");    
    return 0;   
}
